import subprocess
import os
import requests
import re

# Configuration
FASTCOLL_PATH = "./fastcoll/fastcoll"
TARGET_URL = "http://mercury.picoctf.net:55343/index.php"

def main():
    try:
        # Generate MD5 collisions
        #print("[*] Generating collisions with fastcoll...")
        subprocess.run([FASTCOLL_PATH, "a"], check=True)

        # Rename the files
        #print("[*] Renaming the files...")
        os.rename("md5_data1", "collision1.pdf")
        os.rename("md5_data2", "collision2.pdf")

        # Verify MD5
        #print("[*] Verifying MD5sum...")
        md5_1 = subprocess.check_output(["md5sum", "collision1.pdf"], text=True).split()[0]
        md5_2 = subprocess.check_output(["md5sum", "collision2.pdf"], text=True).split()[0]
        
        if md5_1 != md5_2:
            raise Exception("The collisions have different hashes!")

        # Upload the files
        #print("[*] Uploading the files...")
        with open("collision1.pdf", "rb") as f1, open("collision2.pdf", "rb") as f2:
            files = {
                'file1': ('collision1.pdf', f1, 'application/pdf'),
                'file2': ('collision2.pdf', f2, 'application/pdf')
            }
            data = {'submit': 'Upload'}
            # Extract the flag
            print("\nFLAG: " + re.search(r'picoCTF\{.*?\}', requests.post(TARGET_URL, files=files, data=data).text).group(0))

    except Exception as e:
        print(f"\n[!] Error: {e}")
        exit(1)

if __name__ == "__main__":
    main()
